/********************************************************************/

#include "Gen.h"

/********************************************************************/

static NSAutoreleasePool *defaultPool=nil;

/********************************************************************/

// Initialize ObjC specific Gen library extensions. This expects to be
// called by genInit after it has finished it's own setup.
void genInitObjC (int argc , char **argv)
{
    // Generate a startup Autorelease pool, so that the main doesn't
    // need to generate one explicitly if it doesn't want to.
    defaultPool = [[NSAutoreleasePool alloc] init];
}

/********************************************************************/

// This reverses everything that getInitObjC does, and expects to be
// called by genShutdown before it has shut anything down.
void genShutdownObjC (void)
{
    // Release our Autorelease pool.
    [defaultPool release];
}

/********************************************************************/

// Determine the project root (directory under the directory that the current
// binary is being run in) and return it as an NSString. 
NSString *getProjectRoot (void)
{
    // Call the CSTRING version and convert to an NSString for return
    return [NSString stringWithCString: getProjectRootCSTRING ()];
}

/********************************************************************/

// Determine the project version (specified in Makefiles/ReleaseNumber) and
// return it as an NSString.
NSString *getProjectVersion (void)
{
    // Call the CSTRING version and convert to an NSString for return
    return [NSString stringWithCString: getProjectVersionCSTRING ()];
}

/********************************************************************/
